;this computes fluxes and colors for a given model at all inclinations 

;substitute appropriate directory
dir='../runenv/'
;dir='../test/'
;number of inclinations
ninc=10
;aperture=1,2 or 3 (aperture in ttsscat.par)
nap=2
;opacities for reddening line, get these from the dust files (kappa),
;or assume ISM if you want to compare to ISM reddening.
kapv=224.8
kapj=63.01
kaph=38.02
kapk=22.52
kapl=9.939

; intrinsic colors of source, taking average for TTS
;j0-h0
jh0=0.77
;h0-k0
hk0=0.43
;k0-l0
kl0=0.8

;magnetic accretion intrinsic colors
;jh0=0.89
;hk0=0.72
;kl0=????

;intrinsic flux.  assuming about a 1 solar luminosity source, 
;a rough guess is k=7.5, but should vary this over a range...
;this doesn't matter for colors, just k-k_0 plot.
k0=7.5
h0=k0+hk0
j0=h0+jh0
l0=k0-kl0

;wavelength J
;total flux
readcol,dir+'flux_J.dat',mu,ftotj,ptotj,skipline=(nap-1)*ninc+1,numline=ninc
;scattered flux
readcol,dir+'sflux_J.dat',mu,fsj,pfsj,skipline=(nap-1)*ninc+2,numline=ninc
;direct flux
readcol,dir+'sflux_J.dat',dj,numline=ninc

;wavelength H
;total flux
readcol,dir+'flux_H.dat',mu,ftoth,ptoth,skipline=(nap-1)*ninc+1,numline=ninc
;scattered flux
readcol,dir+'sflux_H.dat',mu,fsh,pfsh,skipline=(nap-1)*ninc+2,numline=ninc
;direct flux
readcol,dir+'sflux_H.dat',dh,numline=ninc

;wavelength K
;total flux
readcol,dir+'flux_K.dat',mu,ftotk,ptotk,skipline=(nap-1)*ninc+1,numline=ninc
;scattered flux
readcol,dir+'sflux_K.dat',mu,fsk,pfsk,skipline=(nap-1)*ninc+2,numline=ninc
;direct flux
readcol,dir+'sflux_K.dat',dk,numline=ninc

;wavelength L
;total flux
readcol,dir+'flux_L.dat',mu,ftotl,ptotl,skipline=(nap-1)*ninc+1,numline=ninc
;scattered flux
readcol,dir+'sflux_L.dat',mu,fsl,pfsl,skipline=(nap-1)*ninc+2,numline=ninc
;direct flux
readcol,dir+'sflux_L.dat',dl,numline=ninc

;taurus Class I source data
readcol,'Taurusphot.txt',junk,kobs,jkobs,hkobs,klobs,jhobs
readcol,'Tauruspol.txt',junk,kk0obs,pjobs,phobs,pkobs,junk,junk,junk

;compute magnitudes
l=l0-2.5*alog10(ftotl)
k=k0-2.5*alog10(ftotk)
h=h0-2.5*alog10(ftoth)
j=j0-2.5*alog10(ftotj)

;apparent extinction at K (an observable)
kk0=k-k0

;compute colors
jh=j-h
hk=h-k
kl=k-l

;make some plots
a=findgen(17)*(!pi*2/16.)
usersym,cos(a),sin(a),/fill
set_plot,'x'
window,0,xsize=900,ysize=300,retain=2
!p.multi=[0,3,0,0,0]
plot,kk0obs,pjobs,psym=5,xrange=[0,6],yrange=[-10,30],xtitle='K-K_0',$
 ytitle='%P(J)',charsize=2
oplot,kk0,-ptotj*100,psym=-8
plot,kk0obs,phobs,psym=5,xrange=[0,6],yrange=[-10,30],xtitle='K-K_0',$
 ytitle='%P(H)',charsize=2
oplot,kk0,-ptoth*100,psym=-8
plot,kk0obs,pkobs,psym=5,xrange=[0,6],yrange=[-10,30],xtitle='K-K_0',$
 ytitle='%P(K)',charsize=2
oplot,kk0,-ptotk*100,psym=-8

window,1,xsize=600,ysize=300,retain=2
!p.multi=[0,2,0,0,0]

;make reddening lines for dust
Avarr=2*findgen(20)
klred=(kapk-kapl)/kapv*Avarr+kl0
hkred=(kaph-kapk)/kapv*Avarr+hk0
jhred=(kapj-kaph)/kapv*Avarr+jh0

plot,hkobs,jhobs,psym=5,xrange=[0,3.5],yrange=[0,5],ytitle='J-H',$
   xtitle='H-K',charsize=1.3,charthick=1.5,xmargin=[8,0]
oplot,hk,jh,psym=-8,symsize=1.
oplot,hkred,jhred,linestyle=1

plot,klobs,hkobs,psym=5,xrange=[0,3.5],yrange=[0,5],ytitle='H-K',$
   xtitle='K-L',charsize=1.3,charthick=1.5,xmargin=[8,0]
oplot,kl,hk,psym=-8,symsize=1.
oplot,klred,hkred,linestyle=1

plots,2,0.63,psym=5
xyouts,2.2,0.6,'data'
plots,2,.29,psym=8,symsize=1.
xyouts,2.2,.25,'model'

end









