;program to calculate fluxes and colors of peeled images (at
;inclination thete in ttsscat.par.
;convolves image with a PSF, then calculates flux in chosen aperture
;you can choose aperture size and PSF width.

;set parameters
dir='../runenv/'
;dir='../test/'
;label for images (inclination), leave off wavelength
imlab='_80_'
;distance to source
d=140.   ;pc
nx=299
;image radius, from ttsscat.par, needed for pixel size
rmaxi=1500. 
;aperture in arcsec
aper=3.8
;aper=10.714
;aper=35.71
;set ivoigt=1 if you want to convolve with voigt profile
ivoigt=1
;PSF Gaussian FWHM in arcsec
fwhm=.1
wvoigt=0.1   ;wing component (0 is none, will make gaussian profile,
             ;0.5 is a lot!)
ngwidth=6   ; number of gaussian FWHM widths for PSF.  increase if
                                ; wvoigt is big or if result is boxy
                                ; (the box is the size of the PSF)
;reset psf fourier transform if rerunning program
psf_ft=0.

;read in images.  
file1=dir+'eI'+imlab+'J.dat'
readdat,file1,nx,imj
file2=dir+'eI'+imlab+'H.dat'
readdat,file2,nx,imh
file3=dir+'eI'+imlab+'K.dat'
readdat,file3,nx,imk
file4=dir+'eI'+imlab+'L.dat'
readdat,file4,nx,iml

aper=aper*d
print, 'assuming rmaxi= ',rmaxi,'AU'
print,'d (pc) ',d
pixsize=2.*rmaxi/nx
print,'pixel size (AU)',pixsize 
print,'aperture (AU) ',aper


if ivoigt eq 1 then begin

   ;FWHM of voigt profile = 2*wvoigt (did tests in IDL)
    wgauss=fwhm/pixsize*d
    print,'guass width in pixels ',wgauss
    vwide=ngwidth*wgauss

    psf = psf_voigt_2d(vwide,wvoigt,wgauss)
    psf=psf/total(psf)

    imj=convolve(imj,psf,FT_PSF=psf_FT)
    imh=convolve(imh,psf,FT_PSF=psf_FT)
    imk=convolve(imk,psf,FT_PSF=psf_FT)
    iml=convolve(iml,psf,FT_PSF=psf_FT)

;    tmp=fltarr(nx+2*vwide,nx+2*vwide)    
;    tmp(vwide:nx+vwide-1,vwide:nx+vwide-1)=imj
;    tmp=convol(tmp,psf)
;    imj=tmp(vwide:nx+vwide-1,vwide:nx+vwide-1)
;    tmp(vwide:nx+vwide-1,vwide:nx+vwide-1)=imh
;    tmp=convol(tmp,psf)
;    imh=tmp(vwide:nx+vwide-1,vwide:nx+vwide-1)
;    tmp(vwide:nx+vwide-1,vwide:nx+vwide-1)=imk
;    tmp=convol(tmp,psf)
;    imk=tmp(vwide:nx+vwide-1,vwide:nx+vwide-1)
;    tmp(vwide:nx+vwide-1,vwide:nx+vwide-1)=iml
;    tmp=convol(tmp,psf)
;    iml=tmp(vwide:nx+vwide-1,vwide:nx+vwide-1)

endif

;sum flux in aperture
ijmid=fix(nx/2)+1
ap2=aper*aper
pix2=pixsize*pixsize
jtot=0.
htot=0.
ktot=0.
ltot=0.
test=intarr(nx,nx)*0.
for i=0,nx-1 do begin
for j=0,nx-1 do begin
   rad2=(float(i-ijmid)^2+float(j-ijmid)^2)*pix2
;   rad=sqrt(float(i-ijmid)^2+float(j-ijmid)^2)*pixsize
   if (rad2 lt ap2) then begin
;   if (rad lt aper) then begin
     test(i,j)=1
     jtot=jtot+imj(i,j)
     htot=htot+imh(i,j)
     ktot=ktot+imk(i,j)
     ltot=ltot+iml(i,j)
   endif
endfor
endfor

set_plot,'x'
window,0,xsize=nx,ysize=nx,retain=2
test(298,298)=0.   
tvscl,test,channel=1
tvscl,imj^.2,channel=2

print,'j,h,k,l flux (F/F_star) ',jtot,htot,ktot,ltot

;colors

; assumes intrinsic colors of source, taking average for TTS
;j0-h0
jh0=0.77
;h0-k0
hk0=0.43
;k0-l0
kl0=0.8

;magnetic accretion intrinsic colors
;jh0=0.89
;hk0=0.72
;kl0=????

;compute magnitudes
j=-2.5*alog10(jtot)
h=-2.5*alog10(htot)
k=-2.5*alog10(ktot)
l=-2.5*alog10(ltot)

jh=j-h
hk=h-k
kl=k-l

print,'J-H, H-K, K-L',jh,hk,kl

end
