;plot polarization as a function of inclination and wavelength

!p.multi=[0,1,2]

set_plot,'x'

;substitute appropriate directory
dir='../runenv/'
;dir='../testdisk/'
;number of inclinations
ninc=10
;aperture=1,2 or 3 (aperture in ttsscat.par)
nap=3

;read in flux and polarization
readcol,dir+'flux_J.dat',mu,fj,q1,u1,skipline=(nap-1)*ninc+1,numline=ninc
readcol,dir+'flux_H.dat',mu,fh,q2,u2,skipline=(nap-1)*ninc+1,numline=ninc
readcol,dir+'flux_K.dat',mu,fk,q3,u3,skipline=(nap-1)*ninc+1,numline=ninc
readcol,dir+'flux_L.dat',mu,fl,q4,u4,skipline=(nap-1)*ninc+1,numline=ninc
pj=sqrt(q1^2+u1^2)
ph=sqrt(q2^2+u2^2)
pk=sqrt(q3^2+u3^2)
pl=sqrt(q4^2+u4^2)

pol=fltarr(ninc,4)
pol(*,0)=pj
pol(*,1)=ph
pol(*,2)=pk
pol(*,3)=pl

wave=[1.25,1.65,2.2,3.45]

window,0,xsize=700,ysize=700,retain=2
plot,wave,pol(0,*)*100.,xtitle='wavelength (microns)',ytitle='%P',$
  xrange=[1,4],charsize=1.5
oplot,wave,pol(0,*)*100,psym=5
for i=1,ninc-1 do begin
  oplot,wave,pol(i,*)*100
  oplot,wave,pol(i,*)*100,psym=5
endfor

flux=fltarr(ninc,4)
flux(*,0)=fj
flux(*,1)=fh
flux(*,2)=fk
flux(*,3)=fl

plot,wave,flux(ninc-1,*),xtitle='wavelength (microns)',ytitle='F/Fstar',$
  xrange=[1,4],charsize=1.5
oplot,wave,flux(ninc-1,*),psym=5
for i=0,ninc-2 do begin
  oplot,wave,flux(i,*)
  oplot,wave,flux(i,*),psym=5
endfor

end









