;plot polarization as a function of inclination and wavelength

!p.multi=[0,1,2]

set_plot,'x'

;substitute appropriate directory
dir='../runvega/'
dir='../testvega/'
;number of inclinations
ninc=10
;aperture=1,2 or 3 (aperture in ttsscat.par)
nap=3

;read in flux and polarization
readcol,dir+'flux_U.dat',mu,fu,q1,u1,skipline=(nap-1)*ninc+1,numline=ninc
readcol,dir+'flux_B.dat',mu,fb,q2,u2,skipline=(nap-1)*ninc+1,numline=ninc
readcol,dir+'flux_V.dat',mu,fv,q3,u3,skipline=(nap-1)*ninc+1,numline=ninc
readcol,dir+'flux_R.dat',mu,fr,q4,u4,skipline=(nap-1)*ninc+1,numline=ninc
readcol,dir+'flux_I.dat',mu,fi,q5,u5,skipline=(nap-1)*ninc+1,numline=ninc
pu=sqrt(q1^2+u1^2)
pb=sqrt(q2^2+u2^2)
pv=sqrt(q3^2+u3^2)
pr=sqrt(q4^2+u4^2)
pi=sqrt(q5^2+u5^2)

pol=fltarr(ninc,5)
pol(*,0)=pu
pol(*,1)=pb
pol(*,2)=pv
pol(*,3)=pr
pol(*,4)=pi

wave=[0.36,0.45,0.55,0.65,0.8]

window,0,xsize=700,ysize=700,retain=2
plot,wave,pol(0,*)*100.,xtitle='wavelength (microns)',ytitle='%P',$
  xrange=[0.2,1],charsize=1.5
oplot,wave,pol(0,*)*100,psym=5
for i=1,ninc-1 do begin
  oplot,wave,pol(i,*)*100
  oplot,wave,pol(i,*)*100,psym=5
endfor

flux=fltarr(ninc,5)
flux(*,0)=fu
flux(*,1)=fb
flux(*,2)=fv
flux(*,3)=fr
flux(*,4)=fi

plot,wave,flux(ninc-1,*),xtitle='wavelength (microns)',ytitle='F/Fstar',$
  xrange=[0.2,1],charsize=1.5
oplot,wave,flux(0,*),psym=5
for i=0,ninc-2 do begin
  oplot,wave,flux(i,*)
  oplot,wave,flux(i,*),psym=5
endfor

end









